; men rychlosti a smru vtru s CD4021 verze V2
;Vgner Vlastimil
#picaxe 08M2                  ;nastav typ mikrokontrolru pro editor
#no_data                      ;nezapisuje data do EEPROM
setfreq m4                    ;nastaven frekvence na 4Mhz
symbol dout = PINC.4          ;PINC.4 vstup z CD4021
pause 2000                    ;asov prodleva po zapnut napjen 
serout 0,n2400,($FE,$01)      ;vymazn LCD a nastaven na prvn dek prvn sloupec
pause 200                     ;asov prodleva na vymazn LCD
serout 0,n2400,("MERENI RYCHLOSTI") ;zobraz npis na prvnm dku 
serout 0,n2400,($FE,$C1,"A SMERU VETRU") ;zobraz npis na druhm dku     
pause 2000                    ;asov prodleva na zobrazen hlaviky
serout 0,n2400,($FE,$01)      ;vymazn LCD a nastaven na prvn dek,prvn sloupec
pause 200                     ;asov prodleva na vymazn LCD
start:  count 3,1000,w0       ;naten hodnoty frekvence ze snmae pin 3 zatek nekonen smyky
        if w0=0 then          ;pokud nen signl skok na podprogram signl
        gosub signal          ;podprogram signl
        endif                 ;konec pkazu IF
        w3=w0                 ;uloen naten hodnoty pro vpoet km/hod
     	  w0=w0*5               ;dlen 2 ==>   
     	  w1=w0/10              ;pepoet cel Hz na M/S do w1
     	  w2=w0//10             ;pepoet desetiny Hz na M/S do w2
        w3=w3*5               ;vpoet pro KM/HOD
        w3=w3*36              ;vpoet pro KM/HOD  
        w4=w3/100             ;pepoet cel Hz na KM/HOD do w4
        w5=w3//100/10         ;pepoet setiny Hz na KM/HOD do w5
        serout 0,n2400,($FE,$81,#w4,".",#w5," km/hod",32,32,32,32,32,32)  ;zobrazen vpotu na druhm dku
        gosub smer            ;podprogram smr vtru 
        pause 1000            ;asov prodleva ped dalm natenm hodnoty a ustlen zobrazen 
        goto start            ;skok na nvst start
signal: serout 0,n2400,($FE,$01) ;smae LCD
        pause 200             ;asov prodleva na vymazn LCD
        serout 0,n2400,($FE,$84,"Bezvetri") ;zobraz npis bezvt
zobraz: count 3,1000,w0       ;naten hodnoty frekvence ze snmae pin 3 zatek nekonen smyky
        if w0=0 then          ;pokud je w0 rovno nule
        pause 2000            ;asov prodleva ped dalm natenm hodnoty 
        goto zobraz           ;opakuje skok na nvst pkaz
        endif                 ;konec pkazu
        serout 0,n2400,($FE,$01) ;smae npis BEZVETRI na LCD
        pause 200             ;asov prodleva na vymazn LCD
        return                ;ukonen podprogramu signl
smer:   b12=0 b13=1           ;vchoz hodmoty
        pulsout 2,10          'vytvoen pulsu na PINU2 STROBE CD4021
        for b14 = 1 to 8      'potn prchodu 
        if dout = 1 then      ;pokud je PINC.4 "1" pokrauje na dalm dku
        b12 = b12 + b13       ;pite do b12 souet b12 a b13
        endif                 ;konec pkazu IF
        pulsout 1,10          'vytvoen pulsu na PINU 2 CLK CD4021
        b13 = b13 * 2         ;zven hodnoty  b13
        next b14              'ukonen tac smyky  
        low 1                 'PIN 1 vypnut "L"
        low 2                 'PIN 2 vypnut "L"
        select case b12       ;volba zobrazeni smru vtru podle hodnoty napt                                     vstupy CD4021
        case=128 serout 0,n2400,($FE,$C1,"Sever",32,32,32,32,32,32,32)       ;zobrazen smru vtru S  "SEVER"         B0
        case=64 serout 0,n2400,($FE,$C1,"Severovychod",32,32,32,32,32,32,32) ;zobrazen smru vtru SV "SEVEROVCHOD"  B1
        case=32 serout 0,n2400,($FE,$C1,"Vychod",32,32,32,32,32,32,32)       ;zobrazen smru vtru V  "VCHOD"        B2
        case=16 serout 0,n2400,($FE,$C1,"Jihovychod",32,32,32,32,32,32,32)   ;zobrazen smru vtru JV "JIHOVCHOD"    B3
        case=8 serout 0,n2400,($FE,$C1,"Jih",32,32,32,32,32,32,32)           ;zobrazen smru vtru J  "JIH"           B4
        case=4 serout 0,n2400,($FE,$C1,"Jihozapad",32,32,32,32,32,32,32)     ;zobrazen smru vtru JZ "JIHOZPAD"     B5
        case=2 serout 0,n2400,($FE,$C1,"Zapad",32,32,32,32,32,32,32)         ;zobrazen smru vtru Z  "ZPAD"         B6
        case=1 serout 0,n2400,($FE,$C1,"Seveozapad",32,32,32,32,32,32,32)   ;zobrazen smru vtru SZ "SEVEROZPAD"    B7
        b12=0                 ;vynulovn promnn b12
        endselect             ;ukonen pkazu select
        return                ;ukonen pdprogramu smr
        
        
       
                